package cz.mendelu.dnaAnalyser.overlay;


import cz.mendelu.dnaAnalyser.utils.model.Identifiable;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.Data;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.util.List;
import java.util.Map;
import java.util.UUID;

@RestController
@Api(tags = "api/overlay")
@RequestMapping()
public class OverlayController {

    @Autowired
    private OverlayService overlayService;

    @Data
    static class SourceItem implements Identifiable {
        public UUID id;
        public String type;
        public String groupBy;
        public Boolean aggregated;
        public List<Double> intervals;

    }

    @Data
    static class OverlayCreateRequest {


        protected Integer areaSize;

        protected List<SourceItem> sources;

    }

    @Data
    static class OverlayResponse {

        private UUID analyseId;

        private Integer areaSize;

        private String groupBy;

        private List<Double> intervals;
    }

    @PostMapping()
    @ResponseStatus(HttpStatus.OK)
    //@PreAuthorize("isAuthenticated()")
    @ApiOperation("Get overlay Export.")
    public Map<String, OverlayItem> getOverlay(
            @RequestBody @Valid OverlayCreateRequest request
    ) {
        return overlayService.annotationOverlay(request.sources, request.areaSize);
    }



}
